// Copyright 1997 Ubilab, Union Bank of Switzerland. All rights reserved.
// This is part of the Geo system developed by Ubilab's DistrOOSE group.
// Check out: http://www.ubs.com/ubilab/Projects/se/se.html. GLAB-REH-97.

package Geo.Framework.Any;

public interface AnyFrame extends Any {

	// accessing
	public AnyContext getContext();
	public AnyFrameDescriptor getFrameDescriptor();
	public AnyString getTypeName();
	public int size();
	public int fullSize();
	public AnyArray slotNames();
	public AnyArray slotValues();
	
	// accessing slots
	public Any at(AnyString slotName);
	public Any at(String slotName);
	public Any at(AnyString slotName, int pos);
	public Any at(String slotName, int pos);
	public Any slotAt(AnyString slotName);
	public Any slotAt(String slotName);
	public AnyArray arrayAt(AnyString slotName);
	public AnyArray arrayAt(String slotName);
	public int sizeAt(AnyString slotName);
	public int sizeAt(String slotName);
	
	// manipulating slots
	public void append(AnyString slotName, Any newElement);
	public void append(String slotName, Any newElement);
	public void appendArray(AnyString slotName, AnyArray newElements);
	public void appendArray(String slotName, AnyArray newElements);
	public void atPut(AnyString slotName, Any newElement);
	public void atPut(String slotName, Any newElement);
	public void atPut(AnyString slotName, int pos, Any newElement);
	public void atPut(String slotName, int pos, Any newElement);
	public void setSlot(AnyString slotName, Any value);
	public void setSlot(String slotName, Any value);
	public Any remove(AnyString slotName);
	public Any remove(String slotName);
	public Any remove(AnyString slotName, int pos);
	public Any remove(String slotName, int pos);
	
	// testing
	public boolean hasSlot(AnyString slotName);
	public boolean hasSlot(String slotName);
	public boolean isA(AnyString descriptorName);
	public boolean isA(String descriptorName);
	public boolean isKindOf(AnyString descriptorName);
	public boolean isKindOf(String descriptorName);

}
