// Copyright 1997 Ubilab, Union Bank of Switzerland. All rights reserved.
// This is part of the Geo system developed by Ubilab's DistrOOSE group.
// Check out: http://www.ubs.com/ubilab/Projects/se/se.html. GLAB-REH-97.

package Geo.Framework.AnyImpl;

import Geo.Framework.Any.AnyReader;



public class AnyReaderException extends RuntimeException {

	// instance variables
	
	public AnyReader reader;
	public String inputType;


	// constructors
	
	public AnyReaderException() {
		super("Input string has invalid header.");
	}
	
	public AnyReaderException(AnyReader reader) {
		super("Input string has invalid format for reader of type " + reader.getType());
		this.reader = reader;
	}
	
	public AnyReaderException(AnyReader reader, String inputType) {
		super(reader.getType() + " reader can not read type " + inputType);
		this.reader = reader;
		this.inputType = inputType;
	}
	
	public AnyReaderException(String s) {
		super(s);
	}
	
}
