// Copyright 1997 Ubilab, Union Bank of Switzerland. All rights reserved.
// This is part of the Geo system developed by Ubilab's DistrOOSE group.
// Check out: http://www.ubs.com/ubilab/Projects/se/se.html. GLAB-REH-97.

package Geo.Framework.AnyImpl;

import Geo.Framework.Any.*;



public class AnySap {

	// class methods
	
	public static AnyBoolean booleanValue(boolean b) {
		if (b)
			return AnyBooleanImpl.trueObject;
		else
			return AnyBooleanImpl.falseObject;
	}
	
	public static AnyBoolean trueValue() {
		return AnyBooleanImpl.trueObject;
	}
		
	public static AnyBoolean falseValue() {
		return AnyBooleanImpl.falseObject;
	}
	
	public static AnyDouble doubleValue(double d) {
		return new AnyDoubleImpl(d);
	}

	public static AnyString stringValue(String s) {
		return new AnyStringImpl(s);
	}
		
	public static FlatAnyString flatAnyValue(String s) {
		return new FlatAnyStringImpl(s);
	}
	
	public static AnyInteger integerValue(int i) {
		return new AnyIntegerImpl(i);
	}
	
	public static AnyNull nullValue() {
		return AnyNull.nullObject;
	}
	
}
