// Copyright 1997 Ubilab, Union Bank of Switzerland. All rights reserved.
// This is part of the Geo system developed by Ubilab's DistrOOSE group.
// Check out: http://www.ubs.com/ubilab/Projects/se/se.html. GLAB-REH-97.

package Geo.Framework.AnyImpl;

import Geo.Framework.Any.Any;
import Geo.Framework.Any.AnyString;



public class AnyStringImpl extends AnyImpl implements AnyString {

	// instance variables

	protected String value;


	// constructors
	
	protected AnyStringImpl(String s) {
		value = s;
	}
	
	
	// accessing value

	public int asInteger() {
		try { return Integer.parseInt(value); }
		catch (NumberFormatException e) {
			throw new AnyNumberFormatException(this.asString());
		}
	}
	
	public String asString() {
		return value;
	}
	
	
	// comparing

	public boolean isEqual(String aString) {
		return value.equals(aString);
	}
	
	public boolean notEqual(String aString) {
		return !isEqual(aString);
	}
			
	public boolean isEqual(Any anAny) {
		return anAny != null 
			&& anAny instanceof AnyString
			&& anAny.asString().equals(value);
	}	

	public int hashCode() {
		return value.hashCode();
	}


	// testing
	
	public boolean isValueType() {
		return true;
	}

	
	// printing
	
	public String toString() {
		return value;
	}
	
}
