// Copyright 1997 Ubilab, Union Bank of Switzerland. All rights reserved.
// This is part of the Geo system developed by Ubilab's DistrOOSE group.
// Check out: http://www.ubs.com/ubilab/Projects/se/se.html. GLAB-REH-97.

package Geo.Framework.AnyImpl;

import Geo.Framework.Any.*;



public class RobustAnyReaderImpl extends FastAnyReaderImpl {

	// constructors
	
	public RobustAnyReaderImpl() {
	}
	
	
	// accessing
	
	public String getType() {
		return "RobustAnyIO";
	}
	
	
	// protected - reading
	
	protected Any readAnyFrame() {
		try {
			AnyString name = read().asAnyString();
			AnyFrameDescriptor descriptor = context.getSymbolTable().at(name);
			if (descriptor==null) 
				throw new AnyReaderException("FrameDescriptor " + name + " not found in Symboltable");
			AnyFrame frame = new AnyFrameImpl(context, name);
			int size = read().asInteger();
			AnyString slotName;
			Any slotValue;
			for (int i=0; i<size; i++) {
				slotName = read().asAnyString();
				slotValue = read(); 
				frame.setSlot(slotName, slotValue);
				if (slotValue instanceof AnyDummy) {
					dummies.addElement(new AnyFrameDummyHandle(frame, slotName, ((AnyDummy)slotValue).index));
				}
			}  
			readNextToken(); // skip >
			return frame; }
		catch (AnyClassCastException e) {
				throw new AnyReaderException(this);
		}
	}
	
	protected AnyFrameDescriptor readAnyFrameDescriptor() {
		AnyString name = read().asAnyString(); 
		AnyFrameDescriptor descriptor = new AnyFrameDescriptorImpl(context, name);
		Any description, superDescriptor;
		if ( (description = read()).notEqual(null) )
			descriptor.setDescription(description.asAnyString());
		if ( (superDescriptor = read()).notEqual(null) )
			descriptor.setSuperFrameDescriptor(superDescriptor.asAnyFrameDescriptor());
		descriptor.setContents(read().asAnyDictionary());
		readNextToken(); // skip $
		return descriptor; 
	}
	
}
