// Copyright 1997 Ubilab, Union Bank of Switzerland. All rights reserved.
// This is part of the Geo system developed by Ubilab's DistrOOSE group.
// Check out: http://www.ubs.com/ubilab/Projects/se/se.html. GLAB-REH-97.

package Geo.Framework.AnyImpl;

import Geo.Framework.Any.*;



public class RobustAnyWriterImpl extends FastAnyWriterImpl {

	// constructors
	
	public RobustAnyWriterImpl() {
	}
	
	
	// accessing
	
	public String getType() {
		return "RobustAnyIO";
	}
	
	
	// protected - writing
	
	protected void writeAnyFrame(AnyFrame anAnyFrame) {
		addToBuffer(" <");
		write(anAnyFrame.getFrameDescriptor().getName());
		AnyArray names = anAnyFrame.slotNames();
		AnyArray values = anAnyFrame.slotValues();
		int size = 0;
		for (int i=0, s=values.size(); i<s; i++) {
			if ( values.at(i) != null ) 
				size++;
		}
		addToBuffer(" " + size);
		for (int i=0, s=names.size(); i<s; i++) {
			AnyString name = names.at(i).asAnyString();
			if ( values.at(i) != null ) {
				write(name);
				write(anAnyFrame.slotAt(name)); 
			}
		}
		addToBuffer(" >");
	}
	
	protected void writeAnyFrameDescriptor(AnyFrameDescriptor anAnyFrameDescriptor) {
		addToBuffer(" #");
		write(anAnyFrameDescriptor.getName());
		write(anAnyFrameDescriptor.getDescription());
		write(anAnyFrameDescriptor.getSuperFrameDescriptor());
		write(anAnyFrameDescriptor.getContents());
		addToBuffer(" $");
	}
	
}
